// Exercice Ajax
console.log('index.js');

//// Variables
/// Récupération des éléments html
let formHTML = document.querySelector('#form');
let loadedContentHTML = document.querySelector('#loaded-content');
// console.log(formHTML);
// console.log(loadedContentHTML);

// 0. Envoi du formulaire + preventDefault
formHTML.addEventListener("submit", onSubmit);

// Lors de l'envoi du formulaire
function onSubmit(event) {
    event.preventDefault();

    // console.log("onSubmit");

    // 1.3 Récupération la valeur du bouton radio sélectionné
    let radioSelectedHTML = formHTML.querySelector("input[type=radio]:checked");
    let valeur = radioSelectedHTML.value;

    // Quel bouton à été selectionné ?
    switch(valeur) {
        case 'html' :
            // call ajax correspondant
            // console.log("html");

            ajax('php/1-get-html-article.php')
                .then(function (response) {
                    // Le serveur a correctement répondu
                    // console.log(response);
                    loadedContentHTML.innerHTML = response;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
            break;
        
        case 'json' :
            // call ajax correspondant
            // console.log("json");
            ajax('php/2-get-json-data.php')
                .then(function (response) {
                    // Attention, la réponse est en JSON (texte !)
                    // console.log(response);
                    // console.log(typeof response);
                    let responseEnObjet = JSON.parse(response);
                    // console.log(responseEnObjet);

                    // Et on génère le HTML à la volée
                    let chaine = `<ul>`;

                    // Pour chaque contact..
                    for(contact of responseEnObjet) {
                        // .. on crée un <li>
                        chaine += `<li>Je m'apelle <strong>${contact.firstName}</strong> et mon 06 c'est : ${contact.phone}</li>`;
                    }

                    chaine += `</ul>`;

                    loadedContentHTML.innerHTML = chaine;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
            break;
        
        case 'movies' :
            // call ajax correspondant
            // console.log("movies");
            ajax('php/3-get-html-movies.php')
                .then(function (response) {
                    // Le serveur a correctement répondu
                    // console.log(response);
                    loadedContentHTML.innerHTML = response;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
            
            break;
        
        case 'fake':
            // https://jsonplaceholder.typicode.com/
            // Récupérer les photos de l'album 1
            ajax('https://jsonplaceholder.typicode.com/albums/1/photos')
                .then(function (response) {
                    // Attention, la réponse est en JSON (texte !)
                    // console.log(response);
                    // console.log(typeof response);
                    let responseEnObjet = JSON.parse(response);
                    console.log(responseEnObjet);

                    // Et on génère le HTML à la volée
                    let chaine = `<table><tbody>`;

                    // Pour 5 photos..
                    for(let i = 0 ; i < 5 ; i++) {
                        let unePhoto = responseEnObjet[i];
                        // .. on crée une ligne et on affiche :)
                        chaine += `<tr>
                            <td><img src="${unePhoto.thumbnailUrl}" /></td>
                            <td>${unePhoto.id} / ${unePhoto.title}</td>
                        </tr>`;
                    }

                    chaine += `</tbody></table>`;

                    loadedContentHTML.innerHTML = chaine;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
            break;
            
            // Besoin d'une inscription gratuite afin de récupérer notre clé API
            // max : c57e6567b8cca9291d66a7f600a4fa12
            case 'meteo':

                let choixVilleHTML = document.querySelector('#choixVille');
                let choixVille = choixVilleHTML.value;
                console.log(choixVille);

                // Récupérer le temps actuel
                //      https://openweathermap.org/current
                
                ajax(`https://api.openweathermap.org/data/2.5/weather?q=${choixVille}&appid=c57e6567b8cca9291d66a7f600a4fa12&units=metric&lang=fr`)
                .then(function (response) {
                    // Le serveur a correctement répondu
                    console.log(response);
                    let responseEnObjet = JSON.parse(response);
                    console.log(responseEnObjet);

                    loadedContentHTML.innerHTML = responseEnObjet.weather[0].description;

                    // let chaine = `À Paris, il fait 25°, le temps est nuageux`;
                    let chaine = `<p>À ${responseEnObjet.name}, il fait ${responseEnObjet.main.temp}°, le temps est ${responseEnObjet.weather[0].description} <img src="http://openweathermap.org/img/wn/${responseEnObjet.weather[0].icon}@2x.png" title="${responseEnObjet.weather[0].description}" alt="Weather description icon" /></p>`;
                    loadedContentHTML.innerHTML = chaine;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
                
                break;

        default:
            // Pas catholique
            alert('Erreur formulaire');
    }
}


// 2. Call promesse
//  Test de l'exemple de grafikart
//      https://www.grafikart.fr/tutoriels/promise-async-await-875 > Les promesses
let ajax = function (url) {
    // On renvoie une promesse qui prend en paramettre une fonction 
    // avec 2 paramètres, le callback de succès et d'erreur
    return new Promise(function (resolve, reject) {
        // Le reste du code ressemble à la méthode précédente
        let req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.onreadystatechange = function (aEvt) {
            if (req.readyState == 4) {
                if(req.status == 200) {
                    resolve(req.responseText);
                }
                else {
                    reject(req);
                }
            }
        };
        req.send(null);
    })
}
